#include <vtoo/term.h>
#include <vtoo/common.h>
#include "screen_test.h"


void at_init(void);
void at_exit(void);
void at_winch(void);

void redraw(void);


int main (int argc, char **argv) {
   at_init();

   //create a screen
   screen screen_test = alloc_screen_test();

   set_current_screen(screen_test);   

   //from here on out, everything is in the screen logic, not in the main function.
   while (get_current_screen() != NULL) {
     redraw();
     run_current_screen();
   }
   clear();
   return 0;
}

void redraw(void) {
   draw_current_screen();
   flush();
}

void at_init(void) {
   //switch to interactive application style console settings
   term_buffer_full();
   echo_off();   
   toggle_cursor();
   clear();
   //to push forward any escape codes in buffer.
   flush();

   //signal handlers
   atwinch(at_winch);
   atexit(at_exit); 
}

//handles SIGWINCH
void at_winch(void) {
   resize_screens();
   clear();
   redraw();
}

//handles all exit sigs.
void at_exit(void) {
   //un-fuck up the terminal
   set_style(NONE);
   echo_on();
   term_buffer_line();   
   toggle_cursor();
   clear();
   locate(0,0);
   flush();
}


