#include "screen_test.h"
#include <vtoo/term.h>
#include <vtoo/common.h>
#include <vtoo/text.h>
#include <vtoo/input.h>
#include "window_test.h"

define_screen(test)

static void on_draw(screen scr) {
   clear();
   set_style(BOLD);
   print_text_wrapped(0,0,scr->width,scr->height,
         "vtoo includes a powerful screen management system that makes complex interfaces"
         " significantly easier to develop.\n\n"
         "Individual interface screens are defined using predefined macros and a set of static"
         " functions are included to handle the draw, run, size, alloc, and dealloc events respectively."
         "\n\nScreens are able to perform z-ordering as well. The currently open screen is drawn after drawing the parent screen. "
         "If you press 'w' to open a child window now, you will see that this text is still visible beneath the window. You can press 'q' to quit."
         ,ALIGN_LEFT);
}  

static void on_run(screen scr) {
   char c = get_input_charset("wq");
   if (c == 'w') {
      screen win = alloc_window_test(scr,3,10);
      set_current_screen(win);
   }
   else {
      close_current_screen();
   }
}

static void on_size(screen scr) {
   scr->width  = cols();
   scr->height = rows();
   scr->row = 0;
   scr->col = 0;
}

static void on_alloc(screen scr) {
   return;
}

static void on_dealloc(screen scr) {
   return;
}
