#ifndef __SCREENS_H__
#define __SCREENS_H__

typedef struct screen_t *screen;

struct screen_t {
   int row;
   int col;
   int width;
   int height;
   screen parent;
   void (*draw)(screen);
   void (*run) (screen);
   void (*size)(screen);
   void (*dealloc)(screen);
   void *data;
};

screen alloc_screen(screen parent,void (draw)(screen), void (run)(screen), void(size)(screen));

void set_current_screen(screen);

void dealloc_screen(screen);
screen get_current_screen(void);
void resize_screens(void);
void draw_current_screen(void);
void close_current_screen(void);
void run_current_screen(void);

#define define_screen(name)                                              \
  static void on_draw(screen);                                           \
  static void on_run (screen);                                           \
  static void on_size(screen);                                           \
  static void on_alloc(screen);                                          \
  static void on_dealloc(screen);                                        \
  screen alloc_screen_##name(void) {                                     \
     screen ret = alloc_screen(NULL,on_draw,on_run,on_size);             \
     ret->dealloc = on_dealloc;                                          \
     on_alloc(ret);                                                      \
     return ret;                                                         \
  }

#define screen_header(name)         \
  screen alloc_screen_##name(void); \



#endif
