#ifndef __TERM_H__
#define __TERM_H__

#define NONE 0
typedef enum attributes {
   NO_ATTRIBS=0,
   BOLD=1,
   LOW_INTENSITY=2,
   EMPHASIS=4,
   UNDERLINE=8,
   BLINKING=16,
   INVERSE=32,
   BLACK=64,
   RED=128,
   GREEN=256,
   YELLOW=512,
   BLUE=1024,
   MAGENTA=2048,
   CYAN=4096,
   WHITE=8192,
   BLACK_BG=16384,
   RED_BG=32768,
   GREEN_BG=65536,
   YELLOW_BG=131072,
   BLUE_BG=262144,
   MAGENTA_BG=524288,
   CYAN_BG=1048576,
   WHITE_BG=2097152
} attributes;

void term_buffer_full(void);
void term_buffer_line(void);
void term_buffer_none(void);
void toggle_cursor(void);
void flush(void);
int rows(void);
int cols(void);
void clear(void);
void set_style(attributes attribs);
void locate(int row, int column);
void echo_on(void);
void echo_off(void);
void atwinch (void (fun)(void));
#endif
