#include "common.h"
#include "term.h"
#include "string.h"
#include "text.h"

static int getNextSpace(char* text, int start) {
   int i;
   for (i = start; i < strlen(text); i++) {
      if (text[i] == ' ' || text[i] == '\0') {
         return i;
      }
   }
   return strlen(text);
}

static void printFirstN(char *text, int n) {
   int i;
   for (i = 0; i < n && i < strlen(text); i++) 
      putchar(text[i]);
}

void print_text_wrapped(int r,int c,int w,int h,char* text, alignment align) {
   while (h != 0 && strlen(text) > 0) {
      int i = 0, oi = 0;
      if (strlen(text) > w) {
         while (i <= w && i < strlen(text)) {
            oi = i;
            if (text[i] == '\0') break;
            i = getNextSpace(text,i+1);
         }
         if (oi == 0) oi = w;
      }
      else oi = strlen(text);
      
      if (align == ALIGN_MIDDLE) 
         locate (r,c + ((w - oi) / 2));
      else if (align == ALIGN_RIGHT)
         locate (r,c+(w-oi));
      else if (align == ALIGN_LEFT) 
         locate (r,c);
      printFirstN(text,oi);
      r = r + 1;
      h = h - 1;
      if (text[oi] == '\0') break;
      text = text + oi+1;
   }
}

